# -*- coding: utf-8 -*-
"""
Created on Mon Jun 24 10:29:21 2019

@author: lauvl
"""

###plots three graphs to compare sampling
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.dates as mdates
import numpy as np
from IPython import get_ipython
get_ipython().run_line_magic('matplotlib', 'qt')       #Shows plots in separate window

#30min
df = pd.read_excel(r'C:\Users\lauvl\Google Drive\Bachelor 2019\Analysis and modelling\Exported data\Generator\Plot to illustrate sampling\30 min\30min_sample.xlsx')

#360 min
#df = pd.read_excel(r'C:\Users\lauvl\Google Drive\Bachelor 2019\Analysis and modelling\Exported data\Generator\Plot to illustrate sampling\6 hours\360min_sample_temp.xlsx')

#df = df.iloc[::-1].reset_index(drop=True)     #Reverses the order of the data to make it chronological and resets the index accordingly

#print(df)

#df1 = df.iloc[:,0:2]
datetime1 = pd.to_datetime(df.iloc[:,0]).dropna()
measure1 = df.iloc[:,1].dropna()
measurement1 = measure1.apply(lambda x: x.replace(',', '.')).astype('float')
ts1 = pd.concat([datetime1, measurement1], axis=1)
ferdig1 = ts1.set_index('Datetime 1')
#print(ferdig1)
    
datetime2 = pd.to_datetime(df.iloc[:,4]).dropna()
measure2 = df.iloc[:,5].dropna()
measurement2 = measure2.apply(lambda x: x.replace(',', '.')).astype('float')
ts2 = pd.concat([datetime2, measurement2], axis=1)
ferdig2 = ts2.set_index('Datetime 2')
#print(ferdig2)

datetime3 = pd.to_datetime(df.iloc[:,8]).dropna()
measure3 = df.iloc[:,9].dropna()
measurement3 = measure3.apply(lambda x: x.replace(',', '.')).astype('float')
ts3 = pd.concat([datetime3, measurement3], axis=1)
ferdig3 = ts3.set_index('Datetime 3')
#print(ferdig3)

datetime4 = pd.to_datetime(df.iloc[:,12]).dropna()
measure4 = df.iloc[:,13].dropna()
measurement4 = measure4.apply(lambda x: x.replace(',', '.')).astype('float')
ts4 = pd.concat([datetime4, measurement4], axis=1)
ferdig4 = ts4.set_index('Datetime 4')
#print(ferdig3)

############################### Plotting ######################################
plt.rcParams.update({'font.size': 20})

# =============================================================================
# ################# Fire plott i "vindu" for å illustrere alarmgrenser??
# fig, axes = plt.subplots(2,2, sharex=True, sharey=True)
# 
# y1, = axes[0][0].plot(ferdig1, '-o', linewidth=1.5, label='30 min', fillstyle='none')
# y2, = axes[0][1].plot(ferdig2, '-o', linewidth=1.5, label='60 min', fillstyle='none')
# y3, = axes[1][0].plot(ferdig3, '-o', linewidth=1.5, label='360 min', fillstyle='none')
# y4, = axes[1][1].plot(ferdig4, '-o', linewidth=1.5, label='720 min', fillstyle='none')
# 
# axes[0][0].legend(handles=[y1], loc=1)
# axes[0][1].legend(handles=[y2], loc=1)
# axes[1][0].legend(handles=[y3], loc=1)
# axes[1][1].legend(handles=[y4], loc=1)
# 
# axes[0][0].set_ylabel('Power [MW]')
# axes[1][0].set_ylabel('Power [MW]')
# axes[1][0].set_xlabel('Time')
# axes[1][1].set_xlabel('Time')
# 
# monthyearFmt = mdates.DateFormatter('%H:%M')
# axes[1][0].xaxis.set_major_formatter(monthyearFmt)
# axes[1][1].xaxis.set_major_formatter(monthyearFmt)
# 
# plt.show()
# =============================================================================

###################################### Eit plott med fire grafer
fig,ax1 = plt.subplots()

plt.plot(ferdig1, '-o', linewidth=1.5, label='30 min', fillstyle='none')
plt.plot(ferdig2,'--s', linewidth=1.5, label='60 min')
plt.plot(ferdig3, '-.^', linewidth=1.5, label='360 min')
plt.plot(ferdig4, linestyle='dotted', marker='x', linewidth=1.5, label='720 min')
plt.legend()

#ax1.plot(fillstyle='none')
ax1.set_xlabel('Time')
ax1.set_ylabel('Power [MW]')
monthyearFmt = mdates.DateFormatter('%H:%M')
ax1.xaxis.set_major_formatter(monthyearFmt)


### 4 plots on top of each other
fig = plt.figure()#Plot for both graphs
#Plots first graph
fx1=fig.add_subplot(411)
fx1.plot(ferdig1, '--o', fillstyle='none', label='30 min')

#Plots second graph
fx2=fig.add_subplot(412)
fx2.plot(ferdig2, '--o', fillstyle='none', label='60 min')

#Plots third graph
fx3=fig.add_subplot(413)
fx3.plot(ferdig3, '--o', fillstyle='none', label='360 min')

#Plots third graph
fx4=fig.add_subplot(414)
fx4.plot(ferdig4, '--o', fillstyle='none', label='720 min')

monthyearFmt = mdates.DateFormatter('%H:%M')
fx4.xaxis.set_major_formatter(monthyearFmt)

#fig.xlabel('Time')
#fig.ylabel('Power [MW]')
#fig.text(0.04, 0.5, 'Power [MW]', va='center', rotation='vertical')
#fig.text(0.5, 0.04, 'Time', ha='center')
plt.xlabel('Time')
fx1.set_ylabel('Power [MW]')
fx2.set_ylabel('Power [MW]')
fx3.set_ylabel('Power [MW]')
fx4.set_ylabel('Power [MW]')

fx1.legend()
fx2.legend()
fx3.legend()
fx4.legend()